package de.mdelab.expressiondialogs.actions;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.common.ui.action.AbstractActionDelegate;
import org.eclipse.gmf.runtime.diagram.ui.editparts.GraphicalEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.ui.IObjectActionDelegate;

import de.mdelab.expressiondialogs.ChooseActivityOutParameterDialog;
import de.mdelab.expressiondialogs.ChooseActivityOutParameterDialog2;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;

public class EditActivityFinalNodeReturnValueExpression2Action extends AbstractActionDelegate implements IObjectActionDelegate
{

	ChooseActivityOutParameterDialog2	parameterDialog;

	@Override
	protected void doRun(IProgressMonitor progressMonitor)
	{
		//this.getEditPart().addNotify();
		parameterDialog = new ChooseActivityOutParameterDialog2(null);
		parameterDialog.setChangeCommandReceiver(this.getChangeCommandReceiver());
		parameterDialog.setNode(this.getModel());
		//JOptionPane.showInputDialog(this.getActivity());
		parameterDialog.setActivity(this.getActivity());
		parameterDialog.setEditPart(this.getEditPart());

		parameterDialog.open();
		//this.getEditPart().addNotify();
	}

	protected Activity getActivity()
	{
		ActivityFinalNode2EditPart ep = this.getEditPart();
		return (Activity) ((View) ((GraphicalEditPart) ep.getRoot().getChildren().get(0)).getModel()).getElement();
	}

	protected ActivityFinalNode2EditPart getEditPart()
	{
		return (ActivityFinalNode2EditPart) this.getStructuredSelection().getFirstElement();
	}

	protected ActivityFinalNode getModel()
	{
		ActivityFinalNode2EditPart aaEditPart = this.getEditPart();
		return (ActivityFinalNode) ((View) aaEditPart.getModel()).getElement();
	}

	protected TransactionalEditingDomain getChangeCommandReceiver()
	{
		return this.getEditPart().getEditingDomain();
	}
}
