package de.mdelab.expressiondialogs.actions;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.diagram.ui.editparts.CompartmentEditPart;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.StoryNode;

public class EditExpressionActivityNodeExpressionAction2 extends EditExpressionAction
{

	@Override
	protected EClassifier getExpectedClassifier()
	{
		return EcorePackage.eINSTANCE.getEBoolean();
	}

	@Override
	protected MLExpression getExpression()
	{
		return (MLExpression) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}

	@Override
	protected TransactionalEditingDomain getEditingDomain()
	{
		return ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
	}

	@Override
	protected void setNewExpression(MLExpression newExpression)
	{
		MLExpression oldExpression = getExpression();
		StoryNode san = (StoryNode) oldExpression.eContainer();

		//san.getConstraints().remove(oldExpression);
		//san.getConstraints().add(newExpression);
	}

	@Override
	protected EClassifier getContextClassifier()
	{
		// For story action nodes, no context classifier can be specified.
		return null;
	}

	//@Override
	protected Activity getActivity()
	{
		EObject container = ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent().getParent().getModel())
				.getElement();

		while (!(container instanceof Activity))
		{
			container = container.eContainer();
		}

		return (Activity) container;
	}

	@Override
	protected EObject getExpressionOwner()
	{
		return this.getExpression().eContainer();
	}

	@Override
	protected void prepareDialog()
	{
		super.prepareDialog();
		editExpressionDialog.setActivity(getActivity());
		editExpressionDialog.setStructuralFeature(MlsdmPackage.eINSTANCE.getExpressionActivityNode_Expressions());
	}
}
